//  Author : Christian Arild Str Andersen
//  			De Data Pty Ltd
//  Created : Mid 2003
//
// A guid genetator used to generate guids on WCE devices
// Yes we have to do this ourself yet the WCE has commands like TransparentImage
//
// Most of this code is hacked together from code snippets from Newsnet
// Including some C# code
//
// DDGuid.cpp: implementation of the DDGuid class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DDGuid.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDDGuid::CDDGuid()
{
	memset(m_GUID,0,DDGUIDSIZE);
	memset(m_GuidStr,0,DDSTRSIZE);
}

CDDGuid::~CDDGuid()
{

}

BOOL CDDGuid::GenGUID()
{
	HCRYPTPROV hCryptoProvider = NULL;
	LPSTR pStr;
	DDGUID *pguid;
	int i;
	CryptAcquireContext(&hCryptoProvider,NULL,NULL,PROV_RSA_FULL,CRYPT_VERIFYCONTEXT);
	memset(m_GUID,0,DDGUIDSIZE);
	memset(m_GuidStr,0,DDSTRSIZE);

	if(hCryptoProvider)
	{
		// Generate a random number
		CryptGenRandom(hCryptoProvider,DDGUIDSIZE,m_GUID);
		// Release the context
      CryptReleaseContext(hCryptoProvider,0);

      // Format the GUID to the standards
		m_GUID[DDVARIANTBYTE] &= DDVARIANTMASK;
		m_GUID[DDVARIANTBYTE] |=
			(GUIDVARIANTSTANDARD << DDVARIANTSHIFT);
		m_GUID[DDVERSIONBYTE] &= DDVERSIONMASK;
		m_GUID[DDVERSIONBYTE] |=
			(GUIDVERSIONRANDUM << DDVERSIONSHIFT);
      // lets make a string representation of the UID
		pStr = m_GuidStr;
		pguid = (DDGUID *) m_GUID;
		*pStr++ = '{';
		sprintf(pStr,"%08lx",pguid->Data1);
		pStr+=8;
		*pStr++ = '-';

		sprintf(pStr,"%04lx",pguid->Data2);
		pStr+=4;
		*pStr++ = '-';

		sprintf(pStr,"%04lx",pguid->Data3);
		pStr+=4;
		*pStr++ = '-';
		for(i = 0;i <2;i++)
		{
			sprintf(pStr,"%02lx",pguid->Data4[i]);
			pStr+=2;
		}
		*pStr++ = '-';
		for(i = 0;i <6;i++)
		{
			sprintf(pStr,"%02lx",pguid->Data4[i + 2]);
			pStr+=2;
		}
		*pStr = '}';
		// Now lets do the string version
		return TRUE;
	}
	return FALSE;	
}
